' Programming Information
' Programming Date: 27 Feb 04
' Version: 2
'
' This should allow Joystick 1 to control the movement of the ship around the screen.
'
' v_ are variables
' c_ are constants
' l_ are labels
' s_ are subroutines
'

' Definitions
DEFINE c_jyup,$FE	' Joystick pushed up value
DEFINE c_jydn,$FC	' Joystick pushed down value
DEFINE c_jyrt,$FA	' Joystick pushed right value
DEFINE c_jylt,$EE	' Joystick pushed left value
DEFINE c_strt,$EC	' START key value
DEFINE c_rset,$EA	' RESET key value
DEFINE c_t10,$DE	' Thrust 0% with KEY 0 press
DEFINE c_t11,$DC	' Thrust 100% with KEY 1 press
DEFINE v_gtky,$DA	' Get KEY value
DEFINE v_p1x,$BE	' Player 1's x coordinate
DEFINE v_p1Y,$BC	' Player 1's y coordinate
DEFINE v_Z,$BA
	
' Constants
c_jyup=$21		' A less than $21    (A<c_jyup) to move UP
c_jydn=$DC		' A greater than $DC (A>c_jydn) to move DOWN
c_jyrt=$DC		' A greater than $DC (A>c_jyrt) to move RIGHT
c_jylt=$21		' A less than $21    (A<c_jylt) to move LEFT
c_strt=$0C
c_rset=$0B
c_t10=$00
c_t11=$01

' Varaibles
v_gtky=0
v_p1x=50
v_p1y=50
	

' Main Program

l_Main:     
TITLE "SPACE SHIP"	' Uppercase draws the text in all white
AUTHOR "montotronix"	' Lowercase draws the text in rainbow 

KEYPAD 0	' Joystick 1's input for keys
SCREEN 2	' Can only be a 2 or 4 ... with a 2, text comes out nice; with a 4, not so much
SPRITES ON

l_SetColors:
PALETTE $00,$00		' Set background ($00) color to black ($00)
PALETTE $05,$44		' Set Sprite Color 1 ($05) color to purple ($44) 
PALETTE $06,$60		' Set Sprite Color 2 ($06) color to blue ($60)
PALETTE $07,$CA		' Set Sprite Color 3 ($07) color to who knows... ($CA)
PALETTE $08,$FF		' Set Sprite Color 4 ($08) color to who knows... ($FF)


CLS

DO
 PUT (v_p1x,v_p1y),$90,0,8	' Put l_ship sprite#0 8 scan lines high at c_player1x coord, c_player1y coord
 X = v_p1x		' Addition and subtraction can only be accomplished on A/X/Y register
 Y = v_p1y
 
 GOSUB s_GetMovement
 
 v_Z=0:FOR v_Z TO 100:NEXT v_Z		'Small delay, this may do nothing
 
LOOP UNTIL X = 1	' Escape if you got the *

PRINT "DONE!"		' Let you know your out of the loop

s_GetMovement:

' Pressing a diagonal direction will send a positive signal to both the X and Y axis thus giving 
' movement in that diagonal direction

A=JOYY(0)
IF A < c_jyup THEN	' Move UP
 Y = Y - 1
 IF Y < 1 THEN
  v_p1y = 161
 ELSE
  v_p1y = Y
 END IF
END IF

IF A > c_jydn THEN	' Move DOWN
 Y = Y + 1
 IF Y > 161 THEN
  v_p1y = 1
 ELSE
  v_p1y = Y
 END IF
END IF

A=JOYX(0)
IF A < c_jylt THEN	' Move LEFT
 X = X - 1		' Move the ship one byte to the left
 IF X < 1 THEN		' If ship at left edge of screen, then...
  v_p1x = 159		' move it to the right edge of screen
 ELSE			' otherwise, ...
  v_p1x = X		' put the new location back into the v_player1x coordinate
 END IF			
END IF			

IF A > c_jyrt THEN	' Move RIGHT
 X = X + 1
 IF X < 159 THEN
  v_p1x = X
 ELSE
  v_p1x = 1
 END IF
END IF

A = INKEY
X = 0			' Escape the program
IF A = c_rset THEN
 X = 1
ELSE
 X = 0
END IF

RETURN	

.ORG $9000	
.BYTE $10 	;00010000
.BYTE $10 	;00010000
.BYTE $10 	;00010000
.BYTE $38 	;00111000
.BYTE $7C 	;01111100
.BYTE $FE 	;11111110
.BYTE $38 	;00111000
.BYTE $44 	;01000100


'End Program

'How To Compile
'5200bas {filename}.bas
'tasm -65 -b -fFF -q {filename}.asm {filename}.bin